package lightcontainer.interfaces;

import lightcontainer.domains.client.ClientHandler;
import lightcontainer.domains.server.MulticastServerListener;
import lightcontainer.domains.server.UnicastServerListener;
import lightcontainer.protocol.ProtocolWriter;
import lightcontainer.repository.ClientHandlerRepository;

/**
 * A communication interface between a {@link ClientHandler} and the {@link ClientHandlerRepository}.
 */
public interface UnicastCHR {
    /**
     * Setter, allow to define the ServerListener of a repository.
     * @param server ServerListener to set as default.
     */
    void setServerListener(UnicastServerListener server);

    /**
     * Add a ClientHandler.
     * @param client Client Handler to add.
     */
    void addClient(ClientHandler client);

    void respondToClient(String client, ProtocolWriter.ProtocolResult response);
}
