package lightcontainer.protocol.rules.reader;

import lightcontainer.interfaces.ProtocolRepository;
import lightcontainer.protocol.ProtocolReader;
import lightcontainer.protocol.ProtocolWriter;
import lightcontainer.protocol.rules.writer.FilesRule;
import lightcontainer.protocol.rules.writer.SignOkRule;

public class FilelistRule extends ProtocolReader {
    // Constants
    private static final String PATTERN = "^FILELIST\r\n$";

    private ProtocolRepository protocolRep;

    // Constructor
    public FilelistRule(ProtocolRepository protocolRep) {
        super(PATTERN);
        this.protocolRep = protocolRep;
    }

    public class Result extends ProtocolResult { }

    /**
     * Cette méthode est appelée lors de l'exécution de la règle
     * @param data Paramètres pour créer la commande.
     */
    @Override
    protected FilelistRule.Result onExecuted(String... data) {
        FilelistRule.Result result = new Result();
        result.setResultCommand(this.protocolRep.executeWriter(FilesRule.NAME, "endbenja.txt!500"), ResultCmdReceiver.CLIENT);
        return result;
    }
}
